diff --git a/gcc/tree-ssa-ccp.c b/gcc/tree-ssa-ccp.c
index 1bc4c2f..ac8d81e 100644
--- a/gcc/tree-ssa-ccp.c
+++ b/gcc/tree-ssa-ccp.c
@@ -2121,27 +2121,35 @@ gate_ccp (void)
 }
 
 
-struct gimple_opt_pass pass_ccp =
+class pass_ccp : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ccp",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_ccp,				/* gate */
-  do_ssa_ccp,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_CCP,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-  | TODO_update_address_taken
-  | TODO_verify_stmts			/* todo_flags_finish */
- }
-};
+public:
+  pass_ccp(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ccp",
+		      OPTGROUP_NONE,
+		      TV_TREE_CCP,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_update_address_taken | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ccp (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return do_ssa_ccp (); }
+
+}; // class pass_ccp
+
+gimple_opt_pass *
+make_pass_ccp (context &ctxt)
+{
+  return new pass_ccp (ctxt);
+}
 
 
 
@@ -2521,23 +2529,32 @@ execute_fold_all_builtins (void)
 }
 
 
-struct gimple_opt_pass pass_fold_builtins =
+class pass_fold_builtins : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "fab",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_fold_all_builtins,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-    | TODO_update_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_fold_builtins(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "fab",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_fold_all_builtins (); }
+
+}; // class pass_fold_builtins
+
+gimple_opt_pass *
+make_pass_fold_builtins (context &ctxt)
+{
+  return new pass_fold_builtins (ctxt);
+}
diff --git a/gcc/tree-ssa-copy.c b/gcc/tree-ssa-copy.c
index d16756c..f54fb29 100644
--- a/gcc/tree-ssa-copy.c
+++ b/gcc/tree-ssa-copy.c
@@ -827,24 +827,32 @@ gate_copy_prop (void)
   return flag_tree_copy_prop != 0;
 }
 
-struct gimple_opt_pass pass_copy_prop =
+class pass_copy_prop : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "copyprop",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_copy_prop,			/* gate */
-  execute_copy_prop,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_COPY_PROP,			/* tv_id */
-  PROP_ssa | PROP_cfg,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_verify_ssa
-    | TODO_update_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_copy_prop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "copyprop",
+		      OPTGROUP_NONE,
+		      TV_TREE_COPY_PROP,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_verify_ssa | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_copy_prop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_copy_prop (); }
+
+}; // class pass_copy_prop
+
+gimple_opt_pass *
+make_pass_copy_prop (context &ctxt)
+{
+  return new pass_copy_prop (ctxt);
+}
diff --git a/gcc/tree-ssa-copyrename.c b/gcc/tree-ssa-copyrename.c
index 6f49b7e..29fcbb4 100644
--- a/gcc/tree-ssa-copyrename.c
+++ b/gcc/tree-ssa-copyrename.c
@@ -435,22 +435,32 @@ gate_copyrename (void)
   return flag_tree_copyrename != 0;
 }
 
-struct gimple_opt_pass pass_rename_ssa_copies =
+class pass_rename_ssa_copies : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "copyrename",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_copyrename,			/* gate */
-  rename_ssa_copies,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_COPY_RENAME,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa                       /* todo_flags_finish */
- }
-};
+public:
+  pass_rename_ssa_copies(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "copyrename",
+		      OPTGROUP_NONE,
+		      TV_TREE_COPY_RENAME,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_copyrename (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rename_ssa_copies (); }
+
+}; // class pass_rename_ssa_copies
+
+gimple_opt_pass *
+make_pass_rename_ssa_copies (context &ctxt)
+{
+  return new pass_rename_ssa_copies (ctxt);
+}
diff --git a/gcc/tree-ssa-dce.c b/gcc/tree-ssa-dce.c
index 05c58fe..f8c29cf 100644
--- a/gcc/tree-ssa-dce.c
+++ b/gcc/tree-ssa-dce.c
@@ -1643,63 +1643,92 @@ gate_dce (void)
   return flag_tree_dce != 0;
 }
 
-struct gimple_opt_pass pass_dce =
+class pass_dce : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "dce",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dce,				/* gate */
-  tree_ssa_dce,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_DCE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa	                /* todo_flags_finish */
- }
-};
-
-struct gimple_opt_pass pass_dce_loop =
+public:
+  pass_dce(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "dce",
+		      OPTGROUP_NONE,
+		      TV_TREE_DCE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dce (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_dce (); }
+
+}; // class pass_dce
+
+gimple_opt_pass *
+make_pass_dce (context &ctxt)
 {
- {
-  GIMPLE_PASS,
-  "dceloop",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dce,				/* gate */
-  tree_ssa_dce_loop,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_DCE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa	                /* todo_flags_finish */
- }
-};
-
-struct gimple_opt_pass pass_cd_dce =
+  return new pass_dce (ctxt);
+}
+
+class pass_dce_loop : public gimple_opt_pass
+{
+public:
+  pass_dce_loop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "dceloop",
+		      OPTGROUP_NONE,
+		      TV_TREE_DCE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dce (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_dce_loop (); }
+
+}; // class pass_dce_loop
+
+gimple_opt_pass *
+make_pass_dce_loop (context &ctxt)
+{
+  return new pass_dce_loop (ctxt);
+}
+
+class pass_cd_dce : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "cddce",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dce,				/* gate */
-  tree_ssa_cd_dce,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_CD_DCE,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-  | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+public:
+  pass_cd_dce(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cddce",
+		      OPTGROUP_NONE,
+		      TV_TREE_CD_DCE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dce (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_cd_dce (); }
+
+}; // class pass_cd_dce
+
+gimple_opt_pass *
+make_pass_cd_dce (context &ctxt)
+{
+  return new pass_cd_dce (ctxt);
+}
diff --git a/gcc/tree-ssa-dom.c b/gcc/tree-ssa-dom.c
index d650d95..3bcaa2e 100644
--- a/gcc/tree-ssa-dom.c
+++ b/gcc/tree-ssa-dom.c
@@ -854,28 +854,35 @@ gate_dominator (void)
   return flag_tree_dom != 0;
 }
 
-struct gimple_opt_pass pass_dominator =
+class pass_dominator : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "dom",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dominator,			/* gate */
-  tree_ssa_dominator_optimize,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SSA_DOMINATOR_OPTS,		/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_update_ssa
-    | TODO_verify_ssa
-    | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+public:
+  pass_dominator(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "dom",
+		      OPTGROUP_NONE,
+		      TV_TREE_SSA_DOMINATOR_OPTS,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_update_ssa | TODO_verify_ssa | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dominator (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_dominator_optimize (); }
+
+}; // class pass_dominator
+
+gimple_opt_pass *
+make_pass_dominator (context &ctxt)
+{
+  return new pass_dominator (ctxt);
+}
 
 
 /* Given a conditional statement CONDSTMT, convert the
@@ -3059,25 +3066,32 @@ eliminate_degenerate_phis (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_phi_only_cprop =
+class pass_phi_only_cprop : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "phicprop",                           /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_dominator,                       /* gate */
-  eliminate_degenerate_phis,            /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_TREE_PHI_CPROP,                    /* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,                                    /* properties_provided */
-  0,		                        /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_verify_ssa
-    | TODO_verify_stmts
-    | TODO_update_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_phi_only_cprop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "phicprop",
+		      OPTGROUP_NONE,
+		      TV_TREE_PHI_CPROP,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_verify_ssa | TODO_verify_stmts | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dominator (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return eliminate_degenerate_phis (); }
+
+}; // class pass_phi_only_cprop
+
+gimple_opt_pass *
+make_pass_phi_only_cprop (context &ctxt)
+{
+  return new pass_phi_only_cprop (ctxt);
+}
diff --git a/gcc/tree-ssa-dse.c b/gcc/tree-ssa-dse.c
index ad99ea9..b48bdf5 100644
--- a/gcc/tree-ssa-dse.c
+++ b/gcc/tree-ssa-dse.c
@@ -359,22 +359,32 @@ gate_dse (void)
   return flag_tree_dse != 0;
 }
 
-struct gimple_opt_pass pass_dse =
+class pass_dse : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "dse",			/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  gate_dse,			/* gate */
-  tree_ssa_dse,			/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_DSE,			/* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_verify_ssa		/* todo_flags_finish */
- }
-};
+public:
+  pass_dse(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "dse",
+		      OPTGROUP_NONE,
+		      TV_TREE_DSE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_dse (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_dse (); }
+
+}; // class pass_dse
+
+gimple_opt_pass *
+make_pass_dse (context &ctxt)
+{
+  return new pass_dse (ctxt);
+}
diff --git a/gcc/tree-ssa-forwprop.c b/gcc/tree-ssa-forwprop.c
index ac930c6..3587aed 100644
--- a/gcc/tree-ssa-forwprop.c
+++ b/gcc/tree-ssa-forwprop.c
@@ -3136,23 +3136,34 @@ gate_forwprop (void)
   return flag_tree_forwprop;
 }
 
-struct gimple_opt_pass pass_forwprop =
+class pass_forwprop : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "forwprop",			/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  gate_forwprop,		/* gate */
-  ssa_forward_propagate_and_combine,	/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_FORWPROP,		/* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa		/* todo_flags_finish */
- }
-};
+public:
+  pass_forwprop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "forwprop",
+		      OPTGROUP_NONE,
+		      TV_TREE_FORWPROP,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_forwprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return ssa_forward_propagate_and_combine ();
+  }
+
+}; // class pass_forwprop
+
+gimple_opt_pass *
+make_pass_forwprop (context &ctxt)
+{
+  return new pass_forwprop (ctxt);
+}
diff --git a/gcc/tree-ssa-ifcombine.c b/gcc/tree-ssa-ifcombine.c
index 9598eb8..6f511bc 100644
--- a/gcc/tree-ssa-ifcombine.c
+++ b/gcc/tree-ssa-ifcombine.c
@@ -648,23 +648,32 @@ gate_ifcombine (void)
   return 1;
 }
 
-struct gimple_opt_pass pass_tree_ifcombine =
+class pass_tree_ifcombine : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ifcombine",			/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  gate_ifcombine,		/* gate */
-  tree_ssa_ifcombine,		/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_IFCOMBINE,		/* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa		/* todo_flags_finish */
- }
-};
+public:
+  pass_tree_ifcombine(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ifcombine",
+		      OPTGROUP_NONE,
+		      TV_TREE_IFCOMBINE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ifcombine (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_ifcombine (); }
+
+}; // class pass_tree_ifcombine
+
+gimple_opt_pass *
+make_pass_tree_ifcombine (context &ctxt)
+{
+  return new pass_tree_ifcombine (ctxt);
+}
diff --git a/gcc/tree-ssa-loop-ch.c b/gcc/tree-ssa-loop-ch.c
index b8dd1a3..148eca9 100644
--- a/gcc/tree-ssa-loop-ch.c
+++ b/gcc/tree-ssa-loop-ch.c
@@ -255,24 +255,32 @@ gate_ch (void)
   return flag_tree_ch != 0;
 }
 
-struct gimple_opt_pass pass_ch =
+class pass_ch : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ch",					/* name */
-  OPTGROUP_LOOP,                        /* optinfo_flags */
-  gate_ch,				/* gate */
-  copy_loop_headers,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_CH,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_cleanup_cfg
-    | TODO_verify_ssa
-    | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+public:
+  pass_ch(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ch",
+		      OPTGROUP_LOOP,
+		      TV_TREE_CH,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_cleanup_cfg | TODO_verify_ssa | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ch (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return copy_loop_headers (); }
+
+}; // class pass_ch
+
+gimple_opt_pass *
+make_pass_ch (context &ctxt)
+{
+  return new pass_ch (ctxt);
+}
